<?php

/**
 * @package CRM
 * @copyright CiviCRM LLC (c) 2004-2018
 *
 * Generated from xml/schema/CRM/Core/Persistent.xml
 * DO NOT EDIT.  Generated by CRM_Core_CodeGen
 * (GenCodeChecksum:f215d2eac0f061ca085bcee3c4dca25f)
 */

/**
 * Database access object for the Persistent entity.
 */
class CRM_Core_DAO_Persistent extends CRM_Core_DAO {

  /**
   * Static instance to hold the table name.
   *
   * @var string
   */
  static $_tableName = 'civicrm_persistent';

  /**
   * Should CiviCRM log any modifications to this table in the civicrm_log table.
   *
   * @var bool
   */
  static $_log = FALSE;

  /**
   * Persistent Record Id
   *
   * @var int unsigned
   */
  public $id;

  /**
   * Context for which name data pair is to be stored
   *
   * @var string
   */
  public $context;

  /**
   * Name of Context
   *
   * @var string
   */
  public $name;

  /**
   * data associated with name
   *
   * @var longtext
   */
  public $data;

  /**
   * Config Settings
   *
   * @var boolean
   */
  public $is_config;

  /**
   * Class constructor.
   */
  public function __construct() {
    $this->__table = 'civicrm_persistent';
    parent::__construct();
  }

  /**
   * Returns all the column names of this table
   *
   * @return array
   */
  public static function &fields() {
    if (!isset(Civi::$statics[__CLASS__]['fields'])) {
      Civi::$statics[__CLASS__]['fields'] = [
        'id' => [
          'name' => 'id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => ts('Persistent ID'),
          'description' => ts('Persistent Record Id'),
          'required' => TRUE,
          'table_name' => 'civicrm_persistent',
          'entity' => 'Persistent',
          'bao' => 'CRM_Core_BAO_Persistent',
          'localizable' => 0,
        ],
        'context' => [
          'name' => 'context',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => ts('Context'),
          'description' => ts('Context for which name data pair is to be stored'),
          'required' => TRUE,
          'maxlength' => 255,
          'size' => CRM_Utils_Type::HUGE,
          'table_name' => 'civicrm_persistent',
          'entity' => 'Persistent',
          'bao' => 'CRM_Core_BAO_Persistent',
          'localizable' => 0,
        ],
        'name' => [
          'name' => 'name',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => ts('Name'),
          'description' => ts('Name of Context'),
          'required' => TRUE,
          'maxlength' => 255,
          'size' => CRM_Utils_Type::HUGE,
          'table_name' => 'civicrm_persistent',
          'entity' => 'Persistent',
          'bao' => 'CRM_Core_BAO_Persistent',
          'localizable' => 0,
        ],
        'data' => [
          'name' => 'data',
          'type' => CRM_Utils_Type::T_LONGTEXT,
          'title' => ts('Data'),
          'description' => ts('data associated with name'),
          'table_name' => 'civicrm_persistent',
          'entity' => 'Persistent',
          'bao' => 'CRM_Core_BAO_Persistent',
          'localizable' => 0,
        ],
        'is_config' => [
          'name' => 'is_config',
          'type' => CRM_Utils_Type::T_BOOLEAN,
          'title' => ts('Is Configuration?'),
          'description' => ts('Config Settings'),
          'required' => TRUE,
          'default' => '0',
          'table_name' => 'civicrm_persistent',
          'entity' => 'Persistent',
          'bao' => 'CRM_Core_BAO_Persistent',
          'localizable' => 0,
        ],
      ];
      CRM_Core_DAO_AllCoreTables::invoke(__CLASS__, 'fields_callback', Civi::$statics[__CLASS__]['fields']);
    }
    return Civi::$statics[__CLASS__]['fields'];
  }

  /**
   * Return a mapping from field-name to the corresponding key (as used in fields()).
   *
   * @return array
   *   Array(string $name => string $uniqueName).
   */
  public static function &fieldKeys() {
    if (!isset(Civi::$statics[__CLASS__]['fieldKeys'])) {
      Civi::$statics[__CLASS__]['fieldKeys'] = array_flip(CRM_Utils_Array::collect('name', self::fields()));
    }
    return Civi::$statics[__CLASS__]['fieldKeys'];
  }

  /**
   * Returns the names of this table
   *
   * @return string
   */
  public static function getTableName() {
    return self::$_tableName;
  }

  /**
   * Returns if this table needs to be logged
   *
   * @return bool
   */
  public function getLog() {
    return self::$_log;
  }

  /**
   * Returns the list of fields that can be imported
   *
   * @param bool $prefix
   *
   * @return array
   */
  public static function &import($prefix = FALSE) {
    $r = CRM_Core_DAO_AllCoreTables::getImports(__CLASS__, 'persistent', $prefix, []);
    return $r;
  }

  /**
   * Returns the list of fields that can be exported
   *
   * @param bool $prefix
   *
   * @return array
   */
  public static function &export($prefix = FALSE) {
    $r = CRM_Core_DAO_AllCoreTables::getExports(__CLASS__, 'persistent', $prefix, []);
    return $r;
  }

  /**
   * Returns the list of indices
   *
   * @param bool $localize
   *
   * @return array
   */
  public static function indices($localize = TRUE) {
    $indices = [];
    return ($localize && !empty($indices)) ? CRM_Core_DAO_AllCoreTables::multilingualize(__CLASS__, $indices) : $indices;
  }

}
